#include <string>
#include <admin>
#include <adminlib>

new STRING_VERSION[MAX_DATA_LENGTH]="AM_2.50.60_b0.8";

#define MAX_MENU_LENGTH	1500
new g_MenuText[MAX_MENU_LENGTH];

public plugin_init(){
	new Menu[MAX_DATA_LENGTH];
	new iFileAccessRead;
	new error;
		
	//Check settings
	getstrvar("amv_enable_beta",Menu,MAX_NAME_LENGTH);
	iFileAccessRead=getvar("file_access_read");

	if(strstrx(Menu,"menu1")==-1){
		selfmessage("[Menu Display] amv_enable_beta is not set to ^"menu1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	if(!iFileAccessRead){
		selfmessage("[Menu Display] file_access_read is not set to ^"1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	if(!error){
		plugin_registerinfo("Menu Display","Loads text file and displays it in menu style",STRING_VERSION);
		plugin_registercmd("admin_menu_display","admin_menu_display",ACCESS_SAY,"admin_menu_display [Textfile.txt]: stores textfile.txt in vault.ini to load automatically. Players call menu with /stats in chat.");
		plugin_registercmd("say","HandleSay",ACCESS_ALL,"say /stats: displays player stats of server");
	}
	//LADE GESPEICHERTES TEXTFILE FR MENU, FALLS VORHANDEN
	if(get_vaultdata("menu_say_stats",Menu,MAX_DATA_LENGTH)){
		read_file(Menu);
	}
	return PLUGIN_CONTINUE;
}

//MAIN FUNCTIONS
public admin_menu_display(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	
	//g_MenuText vorbereiten
	if(strstrx(Data,".txt")!=-1){
		if(read_file(Data)){
			set_vaultdata("menu_say_stats",Data);
			selfmessage("[Menu Display] Filename.txt stored in vault.ini to load automatically after mapchange");
			display_one(UserName);
		}
	}else{
		selfmessage("[Menu Display] Sorry. Only .txt files supported! Try again!");
	}
	return PLUGIN_HANDLED;
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	strstripquotes(Data);
	if(strcmp(Data,"/stats")==0){
		display_one(UserName);
	}
	return PLUGIN_CONTINUE;
}

//HELPER FUNCTIONS
read_file(File[]){
	new Data[MAX_DATA_LENGTH];
	if(!fileexists(File)){
		snprintf(Data,MAX_DATA_LENGTH,"[Menu Display] File ^"%s^" not found!^nFATAL ERROR",File);
		selfmessage(Data);
		return 0;
	}else{
		strinit(g_MenuText);
		new iFileSize;
		new i;
		iFileSize=filesize(File);
		for(i=1;i<=iFileSize;i++){
			readfile(File,Data,i,MAX_DATA_LENGTH);
			//Zeilenumbruch am Ende der Zeile
			snprintf(Data,MAX_DATA_LENGTH,"%s^n",Data);
			//Anfgen an g_MenuText
			strcat(g_MenuText,Data,MAX_MENU_LENGTH);
			if(strlen(g_MenuText)>=MAX_MENU_LENGTH){
				selfmessage("[Menu Display] Max. text length reached for menu display!! Break!");
				break;
			}
		}
		strcat(g_MenuText,"1. OKAY",MAX_MENU_LENGTH);
	}
	return 1;
}

display_one(Player[]){
	menu(Player,g_MenuText,1);
}

/*
display_all(){
	new Player[MAX_NAME_LENGTH];
	new maxplayers=maxplayercount();
	new i;
	strcat(g_MenuText,"^n1. Okay",MAX_MENU_LENGTH);
	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH)){
			menu(Player,g_MenuText,1);
		}
	}
}
*/




